package geniusweb.events;

import java.util.List;

import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonProperty;

import geniusweb.actions.PartyId;

public class SessionStarted extends ProtocolEvent {
	private Long sessionNumber;
	private List<PartyId> parties;

	@JsonCreator
	public SessionStarted(@JsonProperty("sessionNumber") Long sessionnr,
			@JsonProperty("parties") List<PartyId> parties,
			@JsonProperty("time") Long time) {
		super(time);
		this.sessionNumber = sessionnr;
		this.parties = parties;
	}

	public List<PartyId> getParties() {
		return parties;
	}

	public Long getSessionNumber() {
		return sessionNumber;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((parties == null) ? 0 : parties.hashCode());
		result = prime * result
				+ ((sessionNumber == null) ? 0 : sessionNumber.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		SessionStarted other = (SessionStarted) obj;
		if (parties == null) {
			if (other.parties != null)
				return false;
		} else if (!parties.equals(other.parties))
			return false;
		if (sessionNumber == null) {
			if (other.sessionNumber != null)
				return false;
		} else if (!sessionNumber.equals(other.sessionNumber))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "SessionStarted[" + sessionNumber + "," + parties + ","
				+ getTime() + "]";
	}

}
